// This file is composed of three parts - WebSpeech, AJAST and SoundManager.
// Each part has its own license description just before the content.

/***************************************************************************
 * Copyright (C) 2011-2012 by Cameron Wong                                 *
 * name in passport: HUANG GUANNENG                                        *
 * email: hgneng at yahoo.com.cn                                           *
 * website: http://www.eguidedog.net                                       *
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU General Public License             *
 * as published by the Free Software Foundation; either version 2          *
 * of the License, or (at your option) any later version.                  *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * To get detail description of GPL2,                                      *
 * please refer to http://www.gnu.org/licenses/gpl-2.0.htm                 *
 *                                                                         *
 **************************************************************************/

// follwing comment is for passing JSLint: http://www.jslint.com/
/*global document: false, escape: false, soundManager: false, OX: false, MD5: false, window: false */
if (typeof(WebSpeech) === "undefined") {
var WebSpeech = {
//  server: 'http://wa.eguidedog.net/cgi-bin/espeak.pl',
  server: 'http://wa.eguidedog.net/cgi-bin/ekho.pl',
//  http://webanywhere.cs.washington.edu/cgi-bin/ivona/getsound.pl
//  server: 'http://localhost/perl/ivona_cgi.pl',
  setverReturnType: 'MP3',
//  server: 'http://localhost/WebSpeech/ivona.php',
//  serverReturnType: 'URL', // for IVONA SaaS server proxy
  voice: 'EkhoMandarin',
//  voice: 'en',
  speedDelta: 0,
  pitchDelta: 0,
  volumeDelta: 0,

  sm2ready: false,
  speechQueue: [],
  frameStack: [],
  state: 'NONE', // 'SPEAKHTML', 'SPEAK_ONE_CLAUSE', 'SPEAK_PARAGRAPH', 'SPEAK_HEADING', 'SPEAK_FOCUSABLE'
  rootNode: null, // root node of speakHtml
  curNode: null,
  curPos: 0,
  curText: '',
  curSpeech: null,
  foundNewParagraph: false,
  headingTags: 'H1 H2 H3 H4 H5 H6',
  foundNewHeading: false,
  paragraphTags: 'P DIV H1 H2 H3 H4 H5 H6 HR BR',
  foundNewParagraph: false,
  preHighLightNode: null,
  highLightNode: null,
  seperators: [".",
    "。", // Chinese full stop (12290, \u3002)
    ",",
    "，", // Chinese comma
    ";",
    "；", // Chinese semi-colon
    "(",
    "（", // Chinese left brace
    ")",
    "）", // Chinese right brace
    "\n"],

  cacheNode: null,
  cachePos: 0,
  cacheCount: 0,
  cacheMaxCount: 5, // number of speech to pre-cache

  isCtrlKeyDown: false,
  isShiftKeyDown: false,

  htmlStartId: null, // element ID for speakHtml. if null, <body> will be used

  onfinish: function () {},

  text2url: {}, // hash of text (md5 with prefix 's') to sound file url
  text2audio: {}, // hash or text (md5 with prefix 's') to SM object

  debug: true,
  log: function (msg) {
    // there should be such element in page: <div id='WebSpeechLog'></div>
    var logDiv = document.getElementById('WebSpeechLog');
    if (logDiv && this.debug) {
      logDiv.innerHTML += msg + '<br/>';
    }
  },

  getStyle: function (elem, styleName) {
    if (elem.nodeType !== 1) { // Element.nodeType === 1
      return null;
    }

    try {
      if (elem.currentStyle) {
        return elem.currentStyle[styleName];
      } else if (window.getComputedStyle) {
        return window.getComputedStyle(elem, null).getPropertyValue(styleName);
      }
    } catch (e) {
      return null;
    }
  },

  getUrl: function (cmd, text) {
    return this.server + '?cmd=' + cmd + '&voice=' +
      this.voice + '&speedDelta=' + this.speedDelta + '&pitchDelta=' +
      this.pitchDelta + '&volumeDelta=' + this.volumeDelta + '&text=' +
      escape(text);
  },

  playNextSpeech: function () {
    var text, speechId, url, speechRef;

    if (this.voice === 'None') {
      this.speechQueue = [];
      return;
    }

    if (!soundManager.supported()) {
      return;
    }

    if (!this.sm2ready) {
      soundManager.onready(function() { WebSpeech.playNextSpeech(); });
      return;
    }

    // no speech left
    if (this.speechQueue.length === 0) {
      if (this.state === 'SPEAKHTML') {
        text = this.getNextClause();
        if (text) {
          speechId = this.getSpeechId(text);
          this.speechQueue.push(speechId);
          if (!this.text2url[speechId]) {
            url = this.getUrl('SPEAK', text);
            if (this.serverReturnType === 'URL') {
              speechRef = this;
              OX.AJAST.call(url, 'callback', function (isSuccess, result) {
                if (isSuccess) {
                  speechRef.text2url[speechId] = result;
                  speechRef.playNextSpeech();
                }
              });
            } else {
              this.text2url[speechId] = url;
            }
          }
          this.playNextSpeech();
        }
      }
      this.onfinish();
      return;
    } else if (!this.text2url[this.speechQueue[0]]) {
      // audio url is not ready
      return;
    }

    speechId = this.speechQueue.shift();

    if (!this.text2audio[speechId]) {
      this.text2audio[speechId] = soundManager.createSound({
        id: speechId,
        url: this.text2url[speechId],
        multiShot: false
      });
    }

    if (this.state !== 'NONE') {
      this.highLightCurText();
    }

    speechRef = this;
    this.text2audio[speechId].play({
      onfinish: function () {
        speechRef.playNextSpeech();
      }
    });
    this.curSpeech = this.text2audio[speechId];
    this.cacheCount -= 1;
    this.cacheNextSpeech();
  },

  // push speech into queue and play on sequence
  speak: function (text) {
    var speechId, speechRef, url;

    speechId = this.getSpeechId(text);
    this.speechQueue.push(speechId);
    url = this.getUrl('SPEAK', text);
    if (!this.text2url[speechId]) {
      if (this.serverReturnType === 'URL') {
        speechRef = this;
        OX.AJAST.call(url, 'callback', function (isSuccess, result) {
          if (isSuccess) {
            speechRef.text2url[speechId] = result;
            speechRef.playNextSpeech();
          }
        });
      } else {
        this.text2url[speechId] = url;
        this.playNextSpeech();
      }
    } else {
      this.playNextSpeech();
    }
  },

  getSpeechId: function (text) {
    return 's' + this.voice + 's' + this.speedDelta + 'p' + this.pitchDelta +
        'v' + this.volumeDelta + MD5(text);
  },

  disableHighLight: function () {
    var parentNode;

    // disable previous high light
    if (this.highLightNode) {
      parentNode = this.highLightNode.parentNode;
      parentNode.replaceChild(this.preHighLightNode, this.highLightNode);
      if (this.curNode.parentNode === this.highLightNode) {
        if (this.curNode.previousSibling) {
          if (this.curNode.previousSibling.tagName === 'SPAN') {
            this.curPos += this.curNode.previousSibling.firstChild.length;
            if (this.curNode.previousSibling.previousSibling) {
              this.curPos += this.curNode.previousSibling.previousSibling.length;
            }
          } else {
            this.curPos += this.curNode.previousSibling.length;
          }
        }
        this.curNode = this.preHighLightNode;
      } else if (this.curNode.parentNode &&
          this.curNode.parentNode.parentNode === this.highLightNode) {
        this.curNode = this.preHighLightNode;
      }
      this.preHighLightNode = null;
      this.highLightNode = null;
    }
  },

  highLightCurText: function () {
    var part1, part2, part3, parentNode;

    this.disableHighLight();

    if (!this.curNode.nodeValue)
      return;

    // high light new node
    part1 = this.curNode.nodeValue.substr(0, this.curPos - this.curText.length);
    part2 = '<span id="WebSpeechHighLight" style="background-color:#ff0; color:#000">' + this.curText + '</span>';
    part3 = this.curNode.nodeValue.substr(this.curPos);
    this.highLightNode = document.createElement('span');
    this.highLightNode.innerHTML = part1 + part2 + part3;
    parentNode = this.curNode.parentNode;
    this.preHighLightNode = this.curNode;
    parentNode.replaceChild(this.highLightNode, this.curNode);
    if (this.highLightNode.childNodes[0].tagName === 'SPAN') {
      this.curNode = this.highLightNode.childNodes[0].firstChild;
    } else {
      this.curNode = this.highLightNode.childNodes[1].firstChild;
    }
  },

  cacheSpeech: function (speechId) {
    var speechRef;

    if (this.voice === 'None' || !soundManager.supported()) {
      return;
    }

    if (!this.text2audio[speechId]) {
      speechRef = this;
      this.text2audio[speechId] = soundManager.createSound({
        id: speechId,
        url: this.text2url[speechId],
        multiShot: false,
        onfinish: function () {
          speechRef.cacheNextSpeech();
        }
      });
    } else {
      this.cacheNextSpeech();
    }
  },

  cacheNextSpeech: function () {
    var curNode, curPos, curText, text, speechId, url, speechRef;

    this.cacheCount += 1;
    if (this.cacheCount > this.cacheMaxCount) {
      return;
    }

    // backup current position
    curNode = this.curNode;
    curPos = this.curPos;
    curText = this.curText;

    text = this.getNextClause();
    if (text) {
      speechId = this.getSpeechId(text);
      url = this.getUrl('SPEAK', text);
      if (!this.text2url[speechId]) {
        if (this.serverReturnType === 'URL') {
          speechRef = this;
          OX.AJAST.call(url, 'callback', function (isSuccess, result) {
            if (isSuccess) {
              speechRef.text2url[speechId] = result;
              speechRef.cacheSpeech(speechId);
            }
          });
        } else {
          this.text2url[speechId] = url;
          this.cacheSpeech(speechId);
        }
      } else {
        this.cacheSpeech(speechId);
      }
    }

    // restore current position
    this.curText = curText;
    this.curPos = curPos;
    this.curNode = curNode;
  },

  setHtmlStartId: function (id) {
    this.htmlStartId = id;
  },

  speakHtml: function (id) {
    var text, speechId, url, speechRef;

    this.speechQueue = [];

    if (this.voice === 'None') {
      return;
    }

    this.state = 'SPEAKHTML';

    if (id) {
      this.rootNode = document.getElementById(id);
    } else if (this.htmlStartId) {
      this.rootNode = document.getElementById(this.htmlStartId);
    } else {
      this.rootNode = document.body;
    }

    this.curNode = this.rootNode;
    this.curPos = 0;

    // prepare the first speech
    text = this.getNextClause();
    if (!text) {
      return;
    }
    this.cacheNode = this.curNode;
    this.cachePos = this.curPos;
    this.speak(text);

    // prepare next speech
    this.cacheNextSpeech();
  },

  speakPreviousClause: function () {
    var text, speechId, url;

    this.stopHtml();
    this.state = 'SPEAK_ONE_CLAUSE';
    text = this.getPreviousClause(); // this is current clause
    text = this.getPreviousClause(); // this is real previous clause
    this.curPos += text.length;
    if (!text) {
      return;
    }
    this.cacheNode = this.curNode;
    this.cachePos = this.curPos;
    this.speak(text);
  },

  speakNextClause: function () {
    var text;

    this.stopHtml();
    this.state = 'SPEAK_ONE_CLAUSE';
    text = this.getNextClause();
    if (!text) {
      return;
    }
    this.cacheNode = this.curNode;
    this.cachePos = this.curPos;
    this.speak(text);

    // prepare next speech
    this.cacheNextSpeech();
  },

  speakNextParagraph: function () {
    var text;

    this.stopHtml();
    this.state = 'SPEAK_PARAGRAPH';
    this.foundNewParagraph = false;

    do {
      text = this.getNextClause();
    } while (!this.foundNewParagraph && text);

    if (!this.foundNewParagraph) {
      text = 'No more paragraphs.';
    }

    this.speak(text);
  },

  speakPreviousParagraph: function () {
    var text;

    this.stopHtml();
    this.state = 'SPEAK_PARAGRAPH';

    this.getPreviousClause();
    this.getPreviousClause();
    this.foundNewParagraph = false;
    do {
      text = this.getPreviousClause();
    } while (!this.foundNewParagraph && text);

    if (!this.foundNewParagraph) {
      text = 'No more paragraphs.';
    } else {
      text = this.getNextClause();
      text = this.getNextClause();
    }

    this.speak(text);
  },

  speakNextHeading: function () {
    var text;

    this.stopHtml();
    this.state = 'SPEAK_HEADING';
    this.foundNewHeading = false;

    do {
      text = this.getNextClause();
    } while (!this.foundNewHeading && text);

    if (!this.foundNewHeading) {
      text = 'No more headings.';
    }

    this.speak(text);
  },

  speakPreviousHeading: function () {
    var text;

    this.stopHtml();
    this.state = 'SPEAK_HEADING';

    this.getPreviousClause();
    this.getPreviousClause();
    this.foundNewHeading = false;
    do {
      text = this.getPreviousClause();
    } while (!this.foundNewHeading && text);

    if (!this.foundNewHeading) {
      text = 'No more headings.';
    } else if (!text) {
      // the heading is on top of content
      text = this.getNextClause();
    } else {
      text = this.getNextClause();
      text = this.getNextClause();
    }

    this.speak(text);
  },

  getFirstClause: function (text) {
    var i;
    for (i in this.seperators) {
      text = text.split(this.seperators[i], 2)[0];
    }
    text = text.replace(/(^\s*)|(\s*$)/g, '');
    return text;
  },

  getLastClause: function (text) {
    var i, clauses;
    for (i in this.seperators) {
      clauses = text.split(this.seperators[i]);
      text = clauses[clauses.length - 1];
    }
    text = text.replace(/(^\s*)|(\s*$)/g, '');
    return text;
  },

  getPreviousClause: function () {
    var text;
    if (!this.curNode) {
      return '';
    }

    if (this.curNode.nodeName === 'FRAME' ||
        this.curNode.nodeName === 'IFRAME') {
      if (this.curNode.contentDocument) {
        this.frameStack.push(this.curNode);
        this.curNode = this.curNode.contentDocument.body;
      }
    }
    
    if (this.curNode.nodeName === 'NOFRAMES' ||
        this.curNode.nodeName === '#comment' ||
        this.curNode.nodeName === 'NOSCRIPT' ||
        this.getStyle(this.curNode, 'display') === 'none' ||
        this.getStyle(this.curNode, 'visibility') === 'hidden') {
      text = ''; // this is meaningless only for passing JSLint
    } else if (!this.curNode.hasChildNodes()) {
      // text node, try to get text to speak
      if (this.curNode.nodeValue) {
        text = this.curNode.nodeValue.substr(0, this.curPos);
        if (text.length > 0) {
          text = this.getLastClause(text);
          if (text.length > 0) {
            this.curPos = this.curNode.nodeValue.lastIndexOf(text, this.curPos - 1);
            // this is it!
            this.curText = text;
            return text;
          }
        }

        do {
          this.curPos -= 1;
        } while (this.curPos >= 0 &&
            this.curNode.nodeValue.charAt(this.curPos).match(/\s/));
        if (this.curPos >= 0) {
          return this.getPreviousClause();
        }
      }
    } else {
      while (this.curNode.lastChild) {
        this.curNode = this.curNode.lastChild;
      }
      this.curPos = this.curNode.length;
      this.curText = '';
      return this.getPreviousClause();
    }

    if (this.curNode.previousSibling && this.curNode !== this.rootNode) {
      // turn to previous sibling
      this.curNode = this.curNode.previousSibling;
      this.curPos = this.curNode.length;
      this.curText = '';
      return this.getPreviousClause();
    } else {
      // turn to parent node's sibling
      do {
        if (!this.curNode.parentNode) {
          if (this.curNode.nodeName === '#document' &&
              this.frameStack.length > 0) {
            this.curNode = this.frameStack.pop();
          } else {
            this.log('no parent');
            this.curNode = this.rootNode; // something wrong
          }
        } else {
          this.curNode = this.curNode.parentNode;

          if (this.headingTags.indexOf(this.curNode.nodeName) >= 0) { 
            this.foundNewHeading = true;
          }

          if (this.paragraphTags.indexOf(this.curNode.nodeName) >= 0) {
            this.foundNewParagraph = true;
          }
        }
      } while (this.curNode !== this.rootNode && (!this.curNode.previousSibling));

      this.curPos = this.curNode.length;
      this.curText = '';
      if (this.curNode === this.rootNode) {
        return '';
      } else {
        this.curNode = this.curNode.previousSibling;
        return this.getPreviousClause();
      }
    }
  },

  getNextClause: function () {
    var text;

    if (!this.curNode) {
      return '';
    }

    if (this.headingTags.indexOf(this.curNode.nodeName) >= 0) { 
      this.foundNewHeading = true;
    }

    if (this.paragraphTags.indexOf(this.curNode.nodeName) >= 0) {
      this.foundNewParagraph = true;
    }

    if (this.curNode.nodeName === 'NOFRAMES' ||
        this.curNode.nodeName === '#comment' ||
        this.curNode.nodeName === 'NOSCRIPT' ||
        this.getStyle(this.curNode, 'display') === 'none' ||
        this.getStyle(this.curNode, 'visibility') === 'hidden') {
      text = ''; // this is meaningless only for passing JSLint
    } else if (this.curNode.nodeName === 'FRAME' ||
        this.curNode.nodeName === 'IFRAME') {
      this.curPos = 0;
      this.curText = '';
      if (this.curNode.contentDocument) {
        this.frameStack.push(this.curNode);
        this.curNode = this.curNode.contentDocument.body;
        return this.getNextClause();
      }
    } else if (!this.curNode.hasChildNodes()) {
      // text node, try to get text to speak
      if (this.curNode.nodeValue) {
        text = this.curNode.nodeValue.substr(this.curPos,
            this.curNode.nodeValue.length - this.curPos);
        if (text.length > 0) {
          text = this.getFirstClause(text);
          if (text.length > 0) {
            this.curPos = this.curNode.nodeValue.indexOf(text, this.curPos) + text.length;
            // this is it!
            this.curText = text;
            return text;
          }
        }

        do {
          this.curPos += 1;
        } while (this.curPos < this.curNode.nodeValue.length &&
            this.curNode.nodeValue.charAt(this.curPos).match(/\s/));
        if (this.curPos < this.curNode.nodeValue.length) {
          return this.getNextClause();
        }
      }
    } else {
      this.curPos = 0;
      this.curText = '';
      this.curNode = this.curNode.firstChild;
      return this.getNextClause();
    }

    if (this.curNode.nextSibling && this.curNode !== this.rootNode) {
      // turn to next sibling
      this.curNode = this.curNode.nextSibling;
      this.curPos = 0;
      this.curText = '';
      return this.getNextClause();
    } else {
      // turn to parent node's sibling
      this.curPos = 0;
      this.curText = '';
      do {
        if (!this.curNode.parentNode) {
          if (this.curNode.nodeName === '#document' &&
              this.frameStack.length > 0) {
            this.curNode = this.frameStack.pop();
          } else {
            this.log('no parent');
            this.curNode = this.rootNode;
          }
        } else {
          this.curNode = this.curNode.parentNode;
        }
      } while (this.curNode !== this.rootNode && (!this.curNode.nextSibling));

      if (this.curNode === this.rootNode) {
        return '';
      } else {
        this.curNode = this.curNode.nextSibling;
        return this.getNextClause();
      }
    }
  },

  handleNavigationKeyUp: function (e) {
    // Usage: insert follwing code to <body>
    // onkeydown = 'if (typeof(WebSpeech) !== "undefined")
    //     { WebSpeech.handleNavigationKeyUp(event); }'
    // Return true if the key is handled
    // Key event reference: http://www.quirksmode.org/js/keys.html
    var code;
    if (window.event) { // IE
      code = e.keyCode;
    } else if (e.which) { // Netscape/Firefox/Opera
      code = e.which;
    }

    //this.log('key up: ' + code); 
    switch (code) {
    case 17:
      // CTRL (pause)
      this.isCtrlKeyDown = false;
      return false;
    case 16:
      // SHIFT (continue)
      this.isShiftKeyDown = false;
      return false;
    case 38:
      // ARROW-UP (previous sentence)
      if (this.state !== 'SPEAKHTML') {
        return false;
      }
      this.speakPreviousClause();
      return true;
    case 40:
      // ARROW-DOWN (next sentence)
      if (this.state !== 'SPEAKHTML') {
        return false;
      }
      this.speakNextClause();
      return true;
    case 72:
      // h/H (next heading)
      if (this.state !== 'SPEAKHTML') {
        return false;
      } 
      if (this.isShiftKeyDown) {
        // SHIFT + h/H
        this.speakPreviousHeading();
      } else {
        this.speakNextHeading();
      }
      return true;
    case 80:
      // p next paragraph
      if (this.state !== 'SPEAKHTML') {
        return false;
      }
      if (this.isShiftKeyDown) {
        // SHIFT + p/P
        this.speakPreviousParagraph();
      } else {
        this.speakNextParagraph();
      }
      return true;

      // next/previous page

      // TAB (next element)
      // SHIFT + TAB (previous element)
    default:
      //this.log('unhandled key up: ' + code);
      return false;
    }
  },

  handleNavigationKeyDown: function (e) {
    // Usage: insert follwing code to <body>
    // onkeydown = 'if (typeof(WebSpeech) !== "undefined")
    //     { WebSpeech.handleNavigationKeyDown(event); }'
    // Return true if the key is handled
    // Key event reference: http://www.quirksmode.org/js/keys.html
    var code;
    if (window.event) { // IE
      code = e.keyCode;
    } else if (e.which) { // Netscape/Firefox/Opera
      code = e.which;
    }

    //this.log('key down: ' + code); 
    switch (code) {
    case 17:
      // CTRL (pause)
      this.isCtrlKeyDown = true;
      if (this.isShiftKeyDown) {
        if (this.state === 'SPEAKHTML') {
          this.stopHtml();
        } else {
          this.speakHtml();
        }
      } else {
        this.pauseHtml();
      }
      return true;
    case 16:
      // SHIFT (continue)
      this.isShiftKeyDown = true;
      if (this.isCtrlKeyDown) {
        if (this.state === 'SPEAKHTML') {
          this.stopHtml();
        } else {
          this.speakHtml();
        }
      } else {
        this.resumeHtml();
      }
      return true;

    default:
      //this.log('unhandled key down: ' + code);
      return false;
    }
  },

  play: function (name) {
    if (!soundManager.supported()) {
      soundManager.onready(function () { WebSpeech.play(name); });
      return;
    }
    soundManager.play(name, 'sounds/' + name + '.mp3');
  },

  saveMp3: function (text) {
    window.open(this.getUrl('SAVEMP3', text));
  },

  saveOgg: function (text) {
    window.open(this.getUrl('SAVEOGG', text));
  },

  getPhonSymbols: function (text, callback) {
    OX.AJAST.call(this.getUrl('GETPHONSYMBOLS', text), 'callback', callback);
  },

  setVoice: function (voice) {
    if (!soundManager.supported()) {
      soundManager.onready(function () { WebSpeech.setVoice(voice); });
      return;
    }
    this.voice = voice;
  },

  getSpeedDelta: function () { return this.speedDelta; },
  setSpeedDelta: function (speedDelta) {
    if (!soundManager.supported()) {
      soundManager.onready(function () { WebSpeech.setSpeedDelta(speedDelta); });
      return;
    }
    if (speedDelta >= -50 && speedDelta <= 100) {
      this.speedDelta = speedDelta;
    }
    return this.speedDelta;
  },

  getPitchDelta: function () { return this.pitchDelta; },
  setPitchDelta: function (pitchDelta) {
    if (!soundManager.supported()) {
      soundManager.onready(function () { WebSpeech.setPitchDelta(pitchDelta); });
      return;
    }
    if (pitchDelta >= -100 && pitchDelta <= 100) {
      this.pitchDelta = pitchDelta;
    }
    return this.pitchDelta;
  },

  getVolumeDelta: function () { return this.volumeDelta; },
  setVolumeDelta: function (volumeDelta) {
    if (!soundManager.supported()) {
      soundManager.onready(function () { WebSpeech.setVolumeDelta(volumeDelta); });
      return;
    }
    if (volumeDelta >= -100 && volumeDelta <= 100) {
      this.volumeDelta = volumeDelta;
    }
    return this.volumeDelta;
  },

  pause: function () {
    if (this.curSpeech) {
      this.curSpeech.pause();
    }
  },

  pauseHtml: function () {
    if (this.curSpeech) {
      this.curSpeech.pause();
    }
  },

  resume: function () {
    if (this.curSpeech && this.curSpeech.paused) {
      this.curSpeech.resume();
    }
  },

  resumeHtml: function () {
    if (this.state === 'SPEAK_ONE_CLAUSE') {
      this.state = 'SPEAKHTML';
    }

    if (this.curSpeech && this.curSpeech.paused) {
      this.curSpeech.resume();
    } else {
      this.playNextSpeech();
    }
  },

  stop: function () {
    if (this.speechQueue.length > 0) {
      soundManager.stop(this.speechQueue[0]);
      while (this.speechQueue.length > 0) {
        this.speechQueue.pop();
      }
    }
  },

  stopHtml: function () {
    this.speechQueue = [];
    if (this.curSpeech) {
      this.curSpeech.stop();
    }
    this.state = 'NONE';
    this.disableHighLight();
  }
};

// This file contains a simple Javascript broker that encapsulates 
// the AJAST technique, allowing for cross-domain REST 
// (REpresentatoinal State Transfer) calls.
// 
// Copyright (c) 2008 Håvard Stranden <havard.stranden@gmail.com>
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

if(typeof(OX) === 'undefined') OX = {};
OX.AJAST = 
{
  Broker : function(url, callbackparameter, optional_decode_json_response, optional_timeout_milliseconds, optional_default_params)
  {
    this.url = url;
    this.cb = callbackparameter;
    this.params = [];
    this.timeout = optional_timeout_milliseconds || 15000; // Timeout in milliseconds
    if(typeof(optional_default_params) !== 'undefined')
    {
      for(p in optional_default_params)
        this.params.push(p + '=' + encodeURIComponent(optional_default_params[p]));
    }
    
    this.jsonmode = optional_decode_json_response || false;
  },
  
  __callbacks__ : {},
  
  __callid__ : 1,
  
  call: function(url, callbackparameter, callbackfunction, optional_timeout, optional_decode_json_response)
  {
    var callbackid = 'callback' + OX.AJAST.__callid__;
    
    // Append callback parameter (this also implicitly avoids caching, since the callback id is different for each call)
    url += '&' + encodeURIComponent(callbackparameter) + '=' + encodeURIComponent('OX.AJAST.__callbacks__.' + callbackid);
      
    // Create script tag for the call
    var tag = OX.AJAST.createScriptTag(url);
    // Get the head of the document
    var head = document.getElementsByTagName('head').item(0);
    
      
    // Create a timeout function  
    var timedout = function()
    {
      if(OX.AJAST.__callbacks__[callbackid] !== 'undefined') // If the callback still exists...
      {
        // Replace original wrapped callback with a dummy that just deletes itself
        OX.AJAST.__callbacks__[callbackid] = function(){ delete OX.AJAST.__callbacks__[callbackid]; }; 
        // Signal that the call timed out
        callbackfunction(false); 
        // Remove the script tag (timed out)
        head.removeChild(tag); 
      }    
    };
    
    // Create timer for the timeout function
    var timer = setTimeout(timedout, optional_timeout || 15000);
      
    var decode_response = optional_decode_json_response || false;
    
    // Create the callback function          
    OX.AJAST.__callbacks__[callbackid] = function(data)
    {
      // Clear the timeout
      clearTimeout(timer);
      
      if(typeof(data) === 'undefined')
        callbackfunction(false); // Callback with nothing
      else
      {
        callbackfunction(true, decode_response ? eval(data) : data);
      }
      // Replace original callback with a dummy function 
      delete OX.AJAST.__callbacks__[callbackid];
      // Remove the script tag (finished)
      head.removeChild(tag);
    };
    
    // Inject the call
    head.appendChild(tag);
  },
  
  createScriptTag: function(url)
  {
    var s = document.createElement('script');
    s.setAttribute('type', 'text/javascript');
    s.setAttribute('id', 'oxajastcall' + OX.AJAST.Broker.__callid__++);
    s.setAttribute('src', url);
    return s;
  }
};

OX.AJAST.Broker.prototype.call = function(params, callback)
{
  // Create arguments
  var args = [];
  for(p in params)
    args.push(p + '=' + encodeURIComponent(params[p]));
  for(p in this.params)
    args.push(this.params[p]);
  OX.AJAST.call(this.url + '?' + args.join('&'), this.cb, callback, this.timeout, this.jsonmode);
};

/**
*
*  MD5 (Message-Digest Algorithm)
*  http://www.webtoolkit.info/
*
**/
 
var MD5 = function (string) {
 
	function RotateLeft(lValue, iShiftBits) {
		return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
	}
 
	function AddUnsigned(lX,lY) {
		var lX4,lY4,lX8,lY8,lResult;
		lX8 = (lX & 0x80000000);
		lY8 = (lY & 0x80000000);
		lX4 = (lX & 0x40000000);
		lY4 = (lY & 0x40000000);
		lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
		if (lX4 & lY4) {
			return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
		}
		if (lX4 | lY4) {
			if (lResult & 0x40000000) {
				return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
			} else {
				return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
			}
		} else {
			return (lResult ^ lX8 ^ lY8);
		}
 	}
 
 	function F(x,y,z) { return (x & y) | ((~x) & z); }
 	function G(x,y,z) { return (x & z) | (y & (~z)); }
 	function H(x,y,z) { return (x ^ y ^ z); }
	function I(x,y,z) { return (y ^ (x | (~z))); }
 
	function FF(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function GG(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function HH(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function II(a,b,c,d,x,s,ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};
 
	function ConvertToWordArray(string) {
		var lWordCount;
		var lMessageLength = string.length;
		var lNumberOfWords_temp1=lMessageLength + 8;
		var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
		var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
		var lWordArray=Array(lNumberOfWords-1);
		var lBytePosition = 0;
		var lByteCount = 0;
		while ( lByteCount < lMessageLength ) {
			lWordCount = (lByteCount-(lByteCount % 4))/4;
			lBytePosition = (lByteCount % 4)*8;
			lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
			lByteCount++;
		}
		lWordCount = (lByteCount-(lByteCount % 4))/4;
		lBytePosition = (lByteCount % 4)*8;
		lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
		lWordArray[lNumberOfWords-2] = lMessageLength<<3;
		lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
		return lWordArray;
	};
 
	function WordToHex(lValue) {
		var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
		for (lCount = 0;lCount<=3;lCount++) {
			lByte = (lValue>>>(lCount*8)) & 255;
			WordToHexValue_temp = "0" + lByte.toString(16);
			WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
		}
		return WordToHexValue;
	};
 
	function Utf8Encode(string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
 
		}
 
		return utftext;
	};
 
	var x=Array();
	var k,AA,BB,CC,DD,a,b,c,d;
	var S11=7, S12=12, S13=17, S14=22;
	var S21=5, S22=9 , S23=14, S24=20;
	var S31=4, S32=11, S33=16, S34=23;
	var S41=6, S42=10, S43=15, S44=21;
 
	string = Utf8Encode(string);
 
	x = ConvertToWordArray(string);
 
	a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
 
	for (k=0;k<x.length;k+=16) {
		AA=a; BB=b; CC=c; DD=d;
		a=FF(a,b,c,d,x[k+0], S11,0xD76AA478);
		d=FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
		c=FF(c,d,a,b,x[k+2], S13,0x242070DB);
		b=FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
		a=FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
		d=FF(d,a,b,c,x[k+5], S12,0x4787C62A);
		c=FF(c,d,a,b,x[k+6], S13,0xA8304613);
		b=FF(b,c,d,a,x[k+7], S14,0xFD469501);
		a=FF(a,b,c,d,x[k+8], S11,0x698098D8);
		d=FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
		c=FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
		b=FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
		a=FF(a,b,c,d,x[k+12],S11,0x6B901122);
		d=FF(d,a,b,c,x[k+13],S12,0xFD987193);
		c=FF(c,d,a,b,x[k+14],S13,0xA679438E);
		b=FF(b,c,d,a,x[k+15],S14,0x49B40821);
		a=GG(a,b,c,d,x[k+1], S21,0xF61E2562);
		d=GG(d,a,b,c,x[k+6], S22,0xC040B340);
		c=GG(c,d,a,b,x[k+11],S23,0x265E5A51);
		b=GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
		a=GG(a,b,c,d,x[k+5], S21,0xD62F105D);
		d=GG(d,a,b,c,x[k+10],S22,0x2441453);
		c=GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
		b=GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
		a=GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
		d=GG(d,a,b,c,x[k+14],S22,0xC33707D6);
		c=GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
		b=GG(b,c,d,a,x[k+8], S24,0x455A14ED);
		a=GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
		d=GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
		c=GG(c,d,a,b,x[k+7], S23,0x676F02D9);
		b=GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
		a=HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
		d=HH(d,a,b,c,x[k+8], S32,0x8771F681);
		c=HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
		b=HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
		a=HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
		d=HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
		c=HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
		b=HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
		a=HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
		d=HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
		c=HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
		b=HH(b,c,d,a,x[k+6], S34,0x4881D05);
		a=HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
		d=HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
		c=HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
		b=HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
		a=II(a,b,c,d,x[k+0], S41,0xF4292244);
		d=II(d,a,b,c,x[k+7], S42,0x432AFF97);
		c=II(c,d,a,b,x[k+14],S43,0xAB9423A7);
		b=II(b,c,d,a,x[k+5], S44,0xFC93A039);
		a=II(a,b,c,d,x[k+12],S41,0x655B59C3);
		d=II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
		c=II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
		b=II(b,c,d,a,x[k+1], S44,0x85845DD1);
		a=II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
		d=II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
		c=II(c,d,a,b,x[k+6], S43,0xA3014314);
		b=II(b,c,d,a,x[k+13],S44,0x4E0811A1);
		a=II(a,b,c,d,x[k+4], S41,0xF7537E82);
		d=II(d,a,b,c,x[k+11],S42,0xBD3AF235);
		c=II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
		b=II(b,c,d,a,x[k+9], S44,0xEB86D391);
		a=AddUnsigned(a,AA);
		b=AddUnsigned(b,BB);
		c=AddUnsigned(c,CC);
		d=AddUnsigned(d,DD);
	}
 
	var temp = WordToHex(a)+WordToHex(b)+WordToHex(c)+WordToHex(d);
 
	return temp.toLowerCase();
};
/** @license


 SoundManager 2: JavaScript Sound for the Web
 ----------------------------------------------
 http://schillmania.com/projects/soundmanager2/

 Copyright (c) 2007, Scott Schiller. All rights reserved.
 Code provided under the BSD License:
 http://schillmania.com/projects/soundmanager2/license.txt

 V2.97a.20120513
*/
(function(H){function X(X,na){function q(a){return function(d){var e=this._t;!e||!e._a?(e&&e.sID?c._wD(n+"ignoring "+d.type+": "+e.sID):c._wD(n+"ignoring "+d.type),d=null):d=a.call(this,d);return d}}this.flashVersion=8;this.debugMode=!0;this.debugFlash=!1;this.consoleOnly=this.useConsole=!0;this.waitForWindowLoad=!1;this.bgColor="#ffffff";this.useHighPerformance=!1;this.html5PollingInterval=this.flashPollingInterval=null;this.flashLoadTimeout=1E3;this.wmode=null;this.allowScriptAccess="always";this.useFlashBlock=
!1;this.useHTML5Audio=!0;this.html5Test=/^(probably|maybe)$/i;this.preferFlash=!0;this.noSWFCache=!1;this.audioFormats={mp3:{type:['audio/mpeg; codecs="mp3"',"audio/mpeg","audio/mp3","audio/MPA","audio/mpa-robust"],required:!0},mp4:{related:["aac","m4a"],type:['audio/mp4; codecs="mp4a.40.2"',"audio/aac","audio/x-m4a","audio/MP4A-LATM","audio/mpeg4-generic"],required:!1},ogg:{type:["audio/ogg; codecs=vorbis"],required:!1},wav:{type:['audio/wav; codecs="1"',"audio/wav","audio/wave","audio/x-wav"],required:!1}};
this.defaultOptions={autoLoad:!1,autoPlay:!1,from:null,loops:1,onid3:null,onload:null,whileloading:null,onplay:null,onpause:null,onresume:null,whileplaying:null,onposition:null,onstop:null,onfailure:null,onfinish:null,multiShot:!0,multiShotEvents:!1,position:null,pan:0,stream:!0,to:null,type:null,usePolicyFile:!1,volume:100};this.flash9Options={isMovieStar:null,usePeakData:!1,useWaveformData:!1,useEQData:!1,onbufferchange:null,ondataerror:null};this.movieStarOptions={bufferTime:3,serverURL:null,onconnect:null,
duration:null};this.movieID="sm2-container";this.id=na||"sm2movie";this.debugID="soundmanager-debug";this.debugURLParam=/([#?&])debug=1/i;this.versionNumber="V2.97a.20120513";this.movieURL=this.version=null;this.url=X||null;this.altURL=null;this.enabled=this.swfLoaded=!1;this.oMC=null;this.sounds={};this.soundIDs=[];this.didFlashBlock=this.muted=!1;this.filePattern=null;this.filePatterns={flash8:/\.mp3(\?.*)?$/i,flash9:/\.mp3(\?.*)?$/i};this.features={buffering:!1,peakData:!1,waveformData:!1,eqData:!1,
movieStar:!1};this.sandbox={type:null,types:{remote:"remote (domain-based) rules",localWithFile:"local with file access (no internet access)",localWithNetwork:"local with network (internet access only, no local access)",localTrusted:"local, trusted (local+internet access)"},description:null,noRemote:null,noLocal:null};var oa;try{oa="undefined"!==typeof Audio&&"undefined"!==typeof(new Audio).canPlayType}catch(eb){oa=!1}this.hasHTML5=oa;this.html5={usingFlash:null};this.flash={};this.ignoreFlash=this.html5Only=
!1;var Fa,c=this,h=null,n="HTML5::",z,v=navigator.userAgent,l=H,P=l.location.href.toString(),i=document,pa,Y,k,C=[],qa=!0,y,Q=!1,R=!1,r=!1,w=!1,Z=!1,o,Za=0,S,x,ra,I,J,$,Ga,sa,F,aa,ba,K,ta,ua,ca,da,L,Ha,va,$a=["log","info","warn","error"],Ia,ea,Ja,T=null,wa=null,s,xa,M,Ka,fa,ga,ya,t,ha=!1,za=!1,La,Ma,Na,ia=0,U=null,ja,A=null,Oa,ka,V,D,Aa,Ba,Pa,j,Qa=Array.prototype.slice,G=!1,p,Ca,Ra,B,Sa,la=v.match(/(ipad|iphone|ipod)/i),ab=v.match(/firefox/i),E=v.match(/msie/i),bb=v.match(/webkit/i),W=v.match(/safari/i)&&
!v.match(/chrome/i),cb=v.match(/opera/i),ma=v.match(/(mobile|pre\/|xoom)/i)||la,Da=!P.match(/usehtml5audio/i)&&!P.match(/sm2\-ignorebadua/i)&&W&&!v.match(/silk/i)&&v.match(/OS X 10_6_([3-7])/i),Ta="undefined"!==typeof console&&"undefined"!==typeof console.log,Ea="undefined"!==typeof i.hasFocus?i.hasFocus():null,N=W&&"undefined"===typeof i.hasFocus,Ua=!N,Va=/(mp3|mp4|mpa)/i,O=i.location?i.location.protocol.match(/http/i):null,Wa=!O?"http://":"",Xa=/^\s*audio\/(?:x-)?(?:mpeg4|aac|flv|mov|mp4||m4v|m4a|mp4v|3gp|3g2)\s*(?:$|;)/i,
Ya="mpeg4,aac,flv,mov,mp4,m4v,f4v,m4a,mp4v,3gp,3g2".split(","),db=RegExp("\\.("+Ya.join("|")+")(\\?.*)?$","i");this.mimePattern=/^\s*audio\/(?:x-)?(?:mp(?:eg|3))\s*(?:$|;)/i;this.useAltURL=!O;this._global_a=null;if(ma&&(c.useHTML5Audio=!0,c.preferFlash=!1,la))G=c.ignoreFlash=!0;this.supported=this.ok=function(){return A?r&&!w:c.useHTML5Audio&&c.hasHTML5};this.getMovie=function(c){return z(c)||i[c]||l[c]};this.createSound=function(a,d){function e(){f=fa(f);c.sounds[g.id]=new Fa(g);c.soundIDs.push(g.id);
return c.sounds[g.id]}var b,f=null,g=b=null;b="soundManager.createSound(): "+s(!r?"notReady":"notOK");if(!r||!c.ok())return ya(b),!1;"undefined"!==typeof d&&(a={id:a,url:d});f=x(a);f.url=ja(f.url);g=f;g.id.toString().charAt(0).match(/^[0-9]$/)&&c._wD("soundManager.createSound(): "+s("badID",g.id),2);c._wD("soundManager.createSound(): "+g.id+" ("+g.url+")",1);if(t(g.id,!0))return c._wD("soundManager.createSound(): "+g.id+" exists",1),c.sounds[g.id];if(ka(g))b=e(),c._wD("Loading sound "+g.id+" via HTML5"),
b._setup_html5(g);else{if(8<k){if(null===g.isMovieStar)g.isMovieStar=g.serverURL||(g.type?g.type.match(Xa):!1)||g.url.match(db);g.isMovieStar&&(c._wD("soundManager.createSound(): using MovieStar handling"),1<g.loops&&o("noNSLoop"))}g=ga(g,"soundManager.createSound(): ");b=e();if(8===k)h._createSound(g.id,g.loops||1,g.usePolicyFile);else if(h._createSound(g.id,g.url,g.usePeakData,g.useWaveformData,g.useEQData,g.isMovieStar,g.isMovieStar?g.bufferTime:!1,g.loops||1,g.serverURL,g.duration||null,g.autoPlay,
!0,g.autoLoad,g.usePolicyFile),!g.serverURL)b.connected=!0,g.onconnect&&g.onconnect.apply(b);!g.serverURL&&(g.autoLoad||g.autoPlay)&&b.load(g)}!g.serverURL&&g.autoPlay&&b.play();return b};this.destroySound=function(a,d){if(!t(a))return!1;var e=c.sounds[a],b;e._iO={};e.stop();e.unload();for(b=0;b<c.soundIDs.length;b++)if(c.soundIDs[b]===a){c.soundIDs.splice(b,1);break}d||e.destruct(!0);delete c.sounds[a];return!0};this.load=function(a,d){return!t(a)?!1:c.sounds[a].load(d)};this.unload=function(a){return!t(a)?
!1:c.sounds[a].unload()};this.onposition=this.onPosition=function(a,d,e,b){return!t(a)?!1:c.sounds[a].onposition(d,e,b)};this.clearOnPosition=function(a,d,e){return!t(a)?!1:c.sounds[a].clearOnPosition(d,e)};this.start=this.play=function(a,d){var e=!1;if(!r||!c.ok())return ya("soundManager.play(): "+s(!r?"notReady":"notOK")),e;if(!t(a)){d instanceof Object||(d={url:d});if(d&&d.url)c._wD('soundManager.play(): attempting to create "'+a+'"',1),d.id=a,e=c.createSound(d).play();return e}return c.sounds[a].play(d)};
this.setPosition=function(a,d){return!t(a)?!1:c.sounds[a].setPosition(d)};this.stop=function(a){if(!t(a))return!1;c._wD("soundManager.stop("+a+")",1);return c.sounds[a].stop()};this.stopAll=function(){var a;c._wD("soundManager.stopAll()",1);for(a in c.sounds)c.sounds.hasOwnProperty(a)&&c.sounds[a].stop()};this.pause=function(a){return!t(a)?!1:c.sounds[a].pause()};this.pauseAll=function(){var a;for(a=c.soundIDs.length-1;0<=a;a--)c.sounds[c.soundIDs[a]].pause()};this.resume=function(a){return!t(a)?
!1:c.sounds[a].resume()};this.resumeAll=function(){var a;for(a=c.soundIDs.length-1;0<=a;a--)c.sounds[c.soundIDs[a]].resume()};this.togglePause=function(a){return!t(a)?!1:c.sounds[a].togglePause()};this.setPan=function(a,d){return!t(a)?!1:c.sounds[a].setPan(d)};this.setVolume=function(a,d){return!t(a)?!1:c.sounds[a].setVolume(d)};this.mute=function(a){var d=0;"string"!==typeof a&&(a=null);if(a){if(!t(a))return!1;c._wD('soundManager.mute(): Muting "'+a+'"');return c.sounds[a].mute()}c._wD("soundManager.mute(): Muting all sounds");
for(d=c.soundIDs.length-1;0<=d;d--)c.sounds[c.soundIDs[d]].mute();return c.muted=!0};this.muteAll=function(){c.mute()};this.unmute=function(a){"string"!==typeof a&&(a=null);if(a){if(!t(a))return!1;c._wD('soundManager.unmute(): Unmuting "'+a+'"');return c.sounds[a].unmute()}c._wD("soundManager.unmute(): Unmuting all sounds");for(a=c.soundIDs.length-1;0<=a;a--)c.sounds[c.soundIDs[a]].unmute();c.muted=!1;return!0};this.unmuteAll=function(){c.unmute()};this.toggleMute=function(a){return!t(a)?!1:c.sounds[a].toggleMute()};
this.getMemoryUse=function(){var c=0;h&&8!==k&&(c=parseInt(h._getMemoryUse(),10));return c};this.disable=function(a){var d;"undefined"===typeof a&&(a=!1);if(w)return!1;w=!0;o("shutdown",1);for(d=c.soundIDs.length-1;0<=d;d--)Ia(c.sounds[c.soundIDs[d]]);S(a);j.remove(l,"load",J);return!0};this.canPlayMIME=function(a){var d;c.hasHTML5&&(d=V({type:a}));!d&&A&&(d=a&&c.ok()?!!(8<k&&a.match(Xa)||a.match(c.mimePattern)):null);return d};this.canPlayURL=function(a){var d;c.hasHTML5&&(d=V({url:a}));!d&&A&&(d=
a&&c.ok()?!!a.match(c.filePattern):null);return d};this.canPlayLink=function(a){return"undefined"!==typeof a.type&&a.type&&c.canPlayMIME(a.type)?!0:c.canPlayURL(a.href)};this.getSoundById=function(a,d){if(!a)throw Error("soundManager.getSoundById(): sID is null/undefined");var e=c.sounds[a];!e&&!d&&c._wD('"'+a+'" is an invalid sound ID.',2);return e};this.onready=function(a,d){var e=!1;if(a&&a instanceof Function)r&&c._wD(s("queue","onready")),d||(d=l),ra("onready",a,d),I();else throw s("needFunction",
"onready");return!0};this.ontimeout=function(a,d){var e=!1;if(a&&a instanceof Function)r&&c._wD(s("queue","ontimeout")),d||(d=l),ra("ontimeout",a,d),I({type:"ontimeout"});else throw s("needFunction","ontimeout");return!0};this._wD=this._writeDebug=function(a,d,e){var b,f;if(!c.debugMode)return!1;"undefined"!==typeof e&&e&&(a=a+" | "+(new Date).getTime());if(Ta&&c.useConsole){e=$a[d];if("undefined"!==typeof console[e])console[e](a);else console.log(a);if(c.consoleOnly)return!0}try{b=z("soundmanager-debug");
if(!b)return!1;f=i.createElement("div");if(0===++Za%2)f.className="sm2-alt";d="undefined"===typeof d?0:parseInt(d,10);f.appendChild(i.createTextNode(a));if(d){if(2<=d)f.style.fontWeight="bold";if(3===d)f.style.color="#ff3333"}b.insertBefore(f,b.firstChild)}catch(g){}return!0};this._debug=function(){var a,d;o("currentObj",1);for(a=0,d=c.soundIDs.length;a<d;a++)c.sounds[c.soundIDs[a]]._debug()};this.reboot=function(){c._wD("soundManager.reboot()");c.soundIDs.length&&c._wD("Destroying "+c.soundIDs.length+
" SMSound objects...");var a,d;for(a=c.soundIDs.length-1;0<=a;a--)c.sounds[c.soundIDs[a]].destruct();try{if(E)wa=h.innerHTML;T=h.parentNode.removeChild(h);c._wD("Flash movie removed.")}catch(e){o("badRemove",2)}wa=T=A=null;c.enabled=ua=r=ha=za=Q=R=w=c.swfLoaded=!1;c.soundIDs=[];c.sounds={};h=null;for(a in C)if(C.hasOwnProperty(a))for(d=C[a].length-1;0<=d;d--)C[a][d].fired=!1;c._wD("soundManager: Rebooting...");l.setTimeout(c.beginDelayedInit,20)};this.getMoviePercent=function(){return h&&"undefined"!==
typeof h.PercentLoaded?h.PercentLoaded():null};this.beginDelayedInit=function(){Z=!0;K();setTimeout(function(){if(za)return!1;da();ba();return za=!0},20);$()};this.destruct=function(){c._wD("soundManager.destruct()");c.disable(!0)};Fa=function(a){var d,e,b=this,f,g,u,m,i,l,r=!1,j=[],q=0,v,w,p=null;d=null;e=null;this.sID=a.id;this.url=a.url;this._iO=this.instanceOptions=this.options=x(a);this.pan=this.options.pan;this.volume=this.options.volume;this.isHTML5=!1;this._a=null;this.id3={};this._debug=
function(){if(c.debugMode){var a=null,d=[],e,f;for(a in b.options)null!==b.options[a]&&(b.options[a]instanceof Function?(e=b.options[a].toString(),e=e.replace(/\s\s+/g," "),f=e.indexOf("{"),d.push(" "+a+": {"+e.substr(f+1,Math.min(Math.max(e.indexOf("\n")-1,64),64)).replace(/\n/g,"")+"... }")):d.push(" "+a+": "+b.options[a]));c._wD("SMSound() merged options: {\n"+d.join(", \n")+"\n}")}};this._debug();this.load=function(a){var d=null;if("undefined"!==typeof a)b._iO=x(a,b.options),b.instanceOptions=
b._iO;else if(a=b.options,b._iO=a,b.instanceOptions=b._iO,p&&p!==b.url)o("manURL"),b._iO.url=b.url,b.url=null;if(!b._iO.url)b._iO.url=b.url;b._iO.url=ja(b._iO.url);c._wD("SMSound.load(): "+b._iO.url,1);if(b._iO.url===b.url&&0!==b.readyState&&2!==b.readyState)return o("onURL",1),3===b.readyState&&b._iO.onload&&b._iO.onload.apply(b,[!!b.duration]),b;a=b._iO;p=b.url;b.loaded=!1;b.readyState=1;b.playState=0;if(ka(a))d=b._setup_html5(a),d._called_load?c._wD(n+"ignoring request to load again: "+b.sID):
(c._wD(n+"load: "+b.sID),b._html5_canplay=!1,b._a.autobuffer="auto",b._a.preload="auto",d._called_load=!0,a.autoPlay?b.play():d.load());else try{b.isHTML5=!1,b._iO=ga(fa(a)),a=b._iO,8===k?h._load(b.sID,a.url,a.stream,a.autoPlay,a.whileloading?1:0,a.loops||1,a.usePolicyFile):h._load(b.sID,a.url,!!a.stream,!!a.autoPlay,a.loops||1,!!a.autoLoad,a.usePolicyFile)}catch(e){o("smError",2),y("onload",!1),L({type:"SMSOUND_LOAD_JS_EXCEPTION",fatal:!0})}return b};this.unload=function(){0!==b.readyState&&(c._wD('SMSound.unload(): "'+
b.sID+'"'),b.isHTML5?(m(),b._a&&(b._a.pause(),Aa(b._a))):8===k?h._unload(b.sID,"about:blank"):h._unload(b.sID),f());return b};this.destruct=function(a){c._wD('SMSound.destruct(): "'+b.sID+'"');if(b.isHTML5){if(m(),b._a)b._a.pause(),Aa(b._a),G||u(),b._a._t=null,b._a=null}else b._iO.onfailure=null,h._destroySound(b.sID);a||c.destroySound(b.sID,!0)};this.start=this.play=function(a,d){var e,f,g;f=null;d=void 0===d?!0:d;a||(a={});b._iO=x(a,b._iO);b._iO=x(b._iO,b.options);b._iO.url=ja(b._iO.url);b.instanceOptions=
b._iO;if(b._iO.serverURL&&!b.connected)return b.getAutoPlay()||(c._wD("SMSound.play():  Netstream not connected yet - setting autoPlay"),b.setAutoPlay(!0)),b;ka(b._iO)&&(b._setup_html5(b._iO),i());if(1===b.playState&&!b.paused)(e=b._iO.multiShot)?c._wD('SMSound.play(): "'+b.sID+'" already playing (multi-shot)',1):(c._wD('SMSound.play(): "'+b.sID+'" already playing (one-shot)',1),f=b);if(null!==f)return f;b.loaded?c._wD('SMSound.play(): "'+b.sID+'"'):0===b.readyState?(c._wD('SMSound.play(): Attempting to load "'+
b.sID+'"',1),b.isHTML5?la&&b.load(b._iO):(b._iO.autoPlay=!0,b.load(b._iO))):2===b.readyState?(c._wD('SMSound.play(): Could not load "'+b.sID+'" - exiting',2),f=b):c._wD('SMSound.play(): "'+b.sID+'" is loading - attempting to play..',1);if(null!==f)return f;if(!b.isHTML5&&9===k&&0<b.position&&b.position===b.duration)c._wD('SMSound.play(): "'+b.sID+'": Sound at end, resetting to position:0'),a.position=0;if(b.paused&&b.position&&0<b.position)c._wD('SMSound.play(): "'+b.sID+'" is resuming from paused state',
1),b.resume();else{b._iO=x(a,b._iO);if(null!==b._iO.from&&null!==b._iO.to&&0===b.instanceCount&&0===b.playState&&!b._iO.serverURL){e=function(){b._iO=x(a,b._iO);b.play(b._iO)};if(b.isHTML5&&!b._html5_canplay)c._wD('SMSound.play(): Beginning load of "'+b.sID+'" for from/to case'),b.load({_oncanplay:e}),f=!1;else if(!b.isHTML5&&!b.loaded&&(!b.readyState||2!==b.readyState))c._wD('SMSound.play(): Preloading "'+b.sID+'" for from/to case'),b.load({onload:e}),f=!1;if(null!==f)return f;b._iO=w()}c._wD('SMSound.play(): "'+
b.sID+'" is starting to play');(!b.instanceCount||b._iO.multiShotEvents||!b.isHTML5&&8<k&&!b.getAutoPlay())&&b.instanceCount++;b._iO.onposition&&0===b.playState&&l(b);b.playState=1;b.paused=!1;b.position="undefined"!==typeof b._iO.position&&!isNaN(b._iO.position)?b._iO.position:0;if(!b.isHTML5)b._iO=ga(fa(b._iO));b._iO.onplay&&d&&(b._iO.onplay.apply(b),r=!0);b.setVolume(b._iO.volume,!0);b.setPan(b._iO.pan,!0);b.isHTML5?(i(),f=b._setup_html5(),b.setPosition(b._iO.position),f.play()):g=h._start(b.sID,
b._iO.loops||1,9===k?b._iO.position:b._iO.position/1E3,b._iO.multiShot);9===k&&!g&&(c._wD("SMSound.play(): "+b.sID+": No sound hardware, or 32-sound ceiling hit"),b._iO.onplayerror&&b._iO.onplayerror.apply(b))}return b};this.stop=function(c){var a=b._iO;if(1===b.playState){b._onbufferchange(0);b._resetOnPosition(0);b.paused=!1;if(!b.isHTML5)b.playState=0;v();a.to&&b.clearOnPosition(a.to);if(b.isHTML5){if(b._a)c=b.position,b.setPosition(0),b.position=c,b._a.pause(),b.playState=0,b._onTimer(),m()}else h._stop(b.sID,
c),a.serverURL&&b.unload();b.instanceCount=0;b._iO={};a.onstop&&a.onstop.apply(b)}return b};this.setAutoPlay=function(a){c._wD("sound "+b.sID+" turned autoplay "+(a?"on":"off"));b._iO.autoPlay=a;b.isHTML5||(h._setAutoPlay(b.sID,a),a&&!b.instanceCount&&1===b.readyState&&(b.instanceCount++,c._wD("sound "+b.sID+" incremented instance count to "+b.instanceCount)))};this.getAutoPlay=function(){return b._iO.autoPlay};this.setPosition=function(a){void 0===a&&(a=0);var d=b.isHTML5?Math.max(a,0):Math.min(b.duration||
b._iO.duration,Math.max(a,0));b.position=d;a=b.position/1E3;b._resetOnPosition(b.position);b._iO.position=d;if(b.isHTML5){if(b._a)if(b._html5_canplay){if(b._a.currentTime!==a){c._wD("setPosition("+a+"): setting position");try{b._a.currentTime=a,(0===b.playState||b.paused)&&b._a.pause()}catch(e){c._wD("setPosition("+a+"): setting position failed: "+e.message,2)}}}else c._wD("setPosition("+a+"): delaying, sound not ready")}else a=9===k?b.position:a,b.readyState&&2!==b.readyState&&h._setPosition(b.sID,
a,b.paused||!b.playState,b._iO.multiShot);b.isHTML5&&b.paused&&b._onTimer(!0);return b};this.pause=function(a){if(b.paused||0===b.playState&&1!==b.readyState)return b;c._wD("SMSound.pause()");b.paused=!0;b.isHTML5?(b._setup_html5().pause(),m()):(a||void 0===a)&&h._pause(b.sID,b._iO.multiShot);b._iO.onpause&&b._iO.onpause.apply(b);return b};this.resume=function(){var a=b._iO;if(!b.paused)return b;c._wD("SMSound.resume()");b.paused=!1;b.playState=1;b.isHTML5?(b._setup_html5().play(),i()):(a.isMovieStar&&
!a.serverURL&&b.setPosition(b.position),h._pause(b.sID,a.multiShot));!r&&a.onplay?(a.onplay.apply(b),r=!0):a.onresume&&a.onresume.apply(b);return b};this.togglePause=function(){c._wD("SMSound.togglePause()");if(0===b.playState)return b.play({position:9===k&&!b.isHTML5?b.position:b.position/1E3}),b;b.paused?b.resume():b.pause();return b};this.setPan=function(a,c){"undefined"===typeof a&&(a=0);"undefined"===typeof c&&(c=!1);b.isHTML5||h._setPan(b.sID,a);b._iO.pan=a;if(!c)b.pan=a,b.options.pan=a;return b};
this.setVolume=function(a,d){"undefined"===typeof a&&(a=100);"undefined"===typeof d&&(d=!1);if(b.isHTML5){if(b._a)b._a.volume=Math.max(0,Math.min(1,a/100))}else h._setVolume(b.sID,c.muted&&!b.muted||b.muted?0:a);b._iO.volume=a;if(!d)b.volume=a,b.options.volume=a;return b};this.mute=function(){b.muted=!0;if(b.isHTML5){if(b._a)b._a.muted=!0}else h._setVolume(b.sID,0);return b};this.unmute=function(){b.muted=!1;var a="undefined"!==typeof b._iO.volume;if(b.isHTML5){if(b._a)b._a.muted=!1}else h._setVolume(b.sID,
a?b._iO.volume:b.options.volume);return b};this.toggleMute=function(){return b.muted?b.unmute():b.mute()};this.onposition=this.onPosition=function(a,c,d){j.push({position:parseInt(a,10),method:c,scope:"undefined"!==typeof d?d:b,fired:!1});return b};this.clearOnPosition=function(b,a){var c,b=parseInt(b,10);if(isNaN(b))return!1;for(c=0;c<j.length;c++)if(b===j[c].position&&(!a||a===j[c].method))j[c].fired&&q--,j.splice(c,1)};this._processOnPosition=function(){var a,c;a=j.length;if(!a||!b.playState||
q>=a)return!1;for(a-=1;0<=a;a--)if(c=j[a],!c.fired&&b.position>=c.position)c.fired=!0,q++,c.method.apply(c.scope,[c.position]);return!0};this._resetOnPosition=function(b){var a,c;a=j.length;if(!a)return!1;for(a-=1;0<=a;a--)if(c=j[a],c.fired&&b<=c.position)c.fired=!1,q--;return!0};w=function(){var a=b._iO,d=a.from,e=a.to,f,g;g=function(){c._wD(b.sID+': "to" time of '+e+" reached.");b.clearOnPosition(e,g);b.stop()};f=function(){c._wD(b.sID+': playing "from" '+d);if(null!==e&&!isNaN(e))b.onPosition(e,
g)};if(null!==d&&!isNaN(d))a.position=d,a.multiShot=!1,f();return a};l=function(){var a,c=b._iO.onposition;if(c)for(a in c)if(c.hasOwnProperty(a))b.onPosition(parseInt(a,10),c[a])};v=function(){var a,c=b._iO.onposition;if(c)for(a in c)c.hasOwnProperty(a)&&b.clearOnPosition(parseInt(a,10))};i=function(){b.isHTML5&&La(b)};m=function(){b.isHTML5&&Ma(b)};f=function(a){a||(j=[],q=0);r=!1;b._hasTimer=null;b._a=null;b._html5_canplay=!1;b.bytesLoaded=null;b.bytesTotal=null;b.duration=b._iO&&b._iO.duration?
b._iO.duration:null;b.durationEstimate=null;b.eqData=[];b.eqData.left=[];b.eqData.right=[];b.failures=0;b.isBuffering=!1;b.instanceOptions={};b.instanceCount=0;b.loaded=!1;b.metadata={};b.readyState=0;b.muted=!1;b.paused=!1;b.peakData={left:0,right:0};b.waveformData={left:[],right:[]};b.playState=0;b.position=null};f();this._onTimer=function(a){var c,f=!1,g={};if(b._hasTimer||a){if(b._a&&(a||(0<b.playState||1===b.readyState)&&!b.paused)){c=b._get_html5_duration();if(c!==d)d=c,b.duration=c,f=!0;b.durationEstimate=
b.duration;c=1E3*b._a.currentTime||0;c!==e&&(e=c,f=!0);(f||a)&&b._whileplaying(c,g,g,g,g)}return f}};this._get_html5_duration=function(){var a=b._iO,c=b._a?1E3*b._a.duration:a?a.duration:void 0;return c&&!isNaN(c)&&Infinity!==c?c:a?a.duration:null};this._apply_loop=function(b,a){!b.loop&&1<a&&c._wD("Note: Native HTML5 looping is infinite.");b.loop=1<a?"loop":""};this._setup_html5=function(a){var a=x(b._iO,a),d=decodeURI,e=G?c._global_a:b._a,u=d(a.url),m=e&&e._t?e._t.instanceOptions:null,i;if(e){if(e._t){if(!G&&
u===d(p))i=e;else if(G&&m.url===a.url&&(!p||p===m.url))i=e;if(i)return b._apply_loop(e,a.loops),i}c._wD("setting new URL on existing object: "+u+(p?", old URL: "+p:""));G&&e._t&&e._t.playState&&a.url!==m.url&&e._t.stop();f(m.url?a.url===m.url:p?p===a.url:!1);e.src=a.url;p=b.url=a.url;e._called_load=!1}else if(c._wD("creating HTML5 Audio() element with URL: "+u),e=new Audio(a.url),e._called_load=!1,G)c._global_a=e;b.isHTML5=!0;b._a=e;e._t=b;g();b._apply_loop(e,a.loops);a.autoLoad||a.autoPlay?b.load():
(e.autobuffer=!1,e.preload="none",ma||b.load());return e};g=function(){if(b._a._added_events)return!1;var a;c._wD(n+"adding event listeners: "+b.sID);b._a._added_events=!0;for(a in B)B.hasOwnProperty(a)&&b._a&&b._a.addEventListener(a,B[a],!1);return!0};u=function(){var a;c._wD(n+"removing event listeners: "+b.sID);b._a._added_events=!1;for(a in B)B.hasOwnProperty(a)&&b._a&&b._a.removeEventListener(a,B[a],!1)};this._onload=function(a){a=!!a;c._wD('SMSound._onload(): "'+b.sID+'"'+(a?" loaded.":" failed to load? - "+
b.url),a?1:2);!a&&!b.isHTML5&&(!0===c.sandbox.noRemote&&c._wD("SMSound._onload(): "+s("noNet"),1),!0===c.sandbox.noLocal&&c._wD("SMSound._onload(): "+s("noLocal"),1));b.loaded=a;b.readyState=a?3:2;b._onbufferchange(0);b._iO.onload&&b._iO.onload.apply(b,[a]);return!0};this._onbufferchange=function(a){if(0===b.playState||a&&b.isBuffering||!a&&!b.isBuffering)return!1;b.isBuffering=1===a;b._iO.onbufferchange&&(c._wD("SMSound._onbufferchange(): "+a),b._iO.onbufferchange.apply(b));return!0};this._onsuspend=
function(){b._iO.onsuspend&&(c._wD("SMSound._onsuspend()"),b._iO.onsuspend.apply(b));return!0};this._onfailure=function(a,d,e){b.failures++;c._wD('SMSound._onfailure(): "'+b.sID+'" count '+b.failures);if(b._iO.onfailure&&1===b.failures)b._iO.onfailure(b,a,d,e);else c._wD("SMSound._onfailure(): ignoring")};this._onfinish=function(){var a=b._iO.onfinish;b._onbufferchange(0);b._resetOnPosition(0);if(b.instanceCount){b.instanceCount--;if(!b.instanceCount)v(),b.playState=0,b.paused=!1,b.instanceCount=
0,b.instanceOptions={},b._iO={},m();if((!b.instanceCount||b._iO.multiShotEvents)&&a)c._wD('SMSound._onfinish(): "'+b.sID+'"'),a.apply(b)}};this._whileloading=function(a,c,d,e){var f=b._iO;b.bytesLoaded=a;b.bytesTotal=c;b.duration=Math.floor(d);b.bufferLength=e;if(f.isMovieStar)b.durationEstimate=b.duration;else if(b.durationEstimate=f.duration?b.duration>f.duration?b.duration:f.duration:parseInt(b.bytesTotal/b.bytesLoaded*b.duration,10),void 0===b.durationEstimate)b.durationEstimate=b.duration;3!==
b.readyState&&f.whileloading&&f.whileloading.apply(b)};this._whileplaying=function(a,c,d,e,f){var g=b._iO;if(isNaN(a)||null===a)return!1;b.position=a;b._processOnPosition();if(!b.isHTML5&&8<k){if(g.usePeakData&&"undefined"!==typeof c&&c)b.peakData={left:c.leftPeak,right:c.rightPeak};if(g.useWaveformData&&"undefined"!==typeof d&&d)b.waveformData={left:d.split(","),right:e.split(",")};if(g.useEQData&&"undefined"!==typeof f&&f&&f.leftEQ&&(a=f.leftEQ.split(","),b.eqData=a,b.eqData.left=a,"undefined"!==
typeof f.rightEQ&&f.rightEQ))b.eqData.right=f.rightEQ.split(",")}1===b.playState&&(!b.isHTML5&&8===k&&!b.position&&b.isBuffering&&b._onbufferchange(0),g.whileplaying&&g.whileplaying.apply(b));return!0};this._oncaptiondata=function(a){c._wD('SMSound._oncaptiondata(): "'+this.sID+'" caption data received.');b.captiondata=a;b._iO.oncaptiondata&&b._iO.oncaptiondata.apply(b)};this._onmetadata=function(a,d){c._wD('SMSound._onmetadata(): "'+this.sID+'" metadata received.');var e={},f,g;for(f=0,g=a.length;f<
g;f++)e[a[f]]=d[f];b.metadata=e;b._iO.onmetadata&&b._iO.onmetadata.apply(b)};this._onid3=function(a,d){c._wD('SMSound._onid3(): "'+this.sID+'" ID3 data received.');var e=[],f,g;for(f=0,g=a.length;f<g;f++)e[a[f]]=d[f];b.id3=x(b.id3,e);b._iO.onid3&&b._iO.onid3.apply(b)};this._onconnect=function(a){a=1===a;c._wD('SMSound._onconnect(): "'+b.sID+'"'+(a?" connected.":" failed to connect? - "+b.url),a?1:2);if(b.connected=a)b.failures=0,t(b.sID)&&(b.getAutoPlay()?b.play(void 0,b.getAutoPlay()):b._iO.autoLoad&&
b.load()),b._iO.onconnect&&b._iO.onconnect.apply(b,[a])};this._ondataerror=function(a){0<b.playState&&(c._wD("SMSound._ondataerror(): "+a),b._iO.ondataerror&&b._iO.ondataerror.apply(b))}};ca=function(){return i.body||i._docElement||i.getElementsByTagName("div")[0]};z=function(a){return i.getElementById(a)};x=function(a,d){var e={},b,f;for(b in a)a.hasOwnProperty(b)&&(e[b]=a[b]);b="undefined"===typeof d?c.defaultOptions:d;for(f in b)b.hasOwnProperty(f)&&"undefined"===typeof e[f]&&(e[f]=b[f]);return e};
j=function(){function a(a){var a=Qa.call(a),b=a.length;e?(a[1]="on"+a[1],3<b&&a.pop()):3===b&&a.push(!1);return a}function c(a,d){var u=a.shift(),m=[b[d]];if(e)u[m](a[0],a[1]);else u[m].apply(u,a)}var e=l.attachEvent,b={add:e?"attachEvent":"addEventListener",remove:e?"detachEvent":"removeEventListener"};return{add:function(){c(a(arguments),"add")},remove:function(){c(a(arguments),"remove")}}}();B={abort:q(function(){c._wD(n+"abort: "+this._t.sID)}),canplay:q(function(){var a=this._t,d;if(a._html5_canplay)return!0;
a._html5_canplay=!0;c._wD(n+"canplay: "+a.sID+", "+a.url);a._onbufferchange(0);d=!isNaN(a.position)?a.position/1E3:null;if(a.position&&this.currentTime!==d){c._wD(n+"canplay: setting position to "+d);try{this.currentTime=d}catch(e){c._wD(n+"setting position failed: "+e.message,2)}}a._iO._oncanplay&&a._iO._oncanplay()}),load:q(function(){var a=this._t;a.loaded||(a._onbufferchange(0),a._whileloading(a.bytesTotal,a.bytesTotal,a._get_html5_duration()),a._onload(!0))}),ended:q(function(){var a=this._t;
c._wD(n+"ended: "+a.sID);a._onfinish()}),error:q(function(){c._wD(n+"error: "+this.error.code);this._t._onload(!1)}),loadeddata:q(function(){var a=this._t,d=a.bytesTotal||1;c._wD(n+"loadeddata: "+this._t.sID);if(!a._loaded&&!W)a.duration=a._get_html5_duration(),a._whileloading(d,d,a._get_html5_duration()),a._onload(!0)}),loadedmetadata:q(function(){c._wD(n+"loadedmetadata: "+this._t.sID)}),loadstart:q(function(){c._wD(n+"loadstart: "+this._t.sID);this._t._onbufferchange(1)}),play:q(function(){c._wD(n+
"play: "+this._t.sID+", "+this._t.url);this._t._onbufferchange(0)}),playing:q(function(){c._wD(n+"playing: "+this._t.sID);this._t._onbufferchange(0)}),progress:q(function(a){var d=this._t,e,b,f;f=0;var g="progress"===a.type;b=a.target.buffered;var u=a.loaded||0,m=a.total||1;if(d.loaded)return!1;if(b&&b.length){for(e=b.length-1;0<=e;e--)f=b.end(e)-b.start(e);u=f/a.target.duration;if(g&&1<b.length){f=[];b=b.length;for(e=0;e<b;e++)f.push(a.target.buffered.start(e)+"-"+a.target.buffered.end(e));c._wD(n+
"progress: timeRanges: "+f.join(", "))}g&&!isNaN(u)&&c._wD(n+"progress: "+d.sID+": "+Math.floor(100*u)+"% loaded")}isNaN(u)||(d._onbufferchange(0),d._whileloading(u,m,d._get_html5_duration()),u&&m&&u===m&&B.load.call(this,a))}),ratechange:q(function(){c._wD(n+"ratechange: "+this._t.sID)}),suspend:q(function(a){var d=this._t;c._wD(n+"suspend: "+d.sID);B.progress.call(this,a);d._onsuspend()}),stalled:q(function(){c._wD(n+"stalled: "+this._t.sID)}),timeupdate:q(function(){this._t._onTimer()}),waiting:q(function(){var a=
this._t;c._wD(n+"waiting: "+a.sID);a._onbufferchange(1)})};ka=function(a){return!a.serverURL&&(a.type?V({type:a.type}):V({url:a.url})||c.html5Only)};Aa=function(a){if(a)a.src=ab?"":"about:blank"};V=function(a){function d(a){return c.preferFlash&&p&&!c.ignoreFlash&&"undefined"!==typeof c.flash[a]&&c.flash[a]}if(!c.useHTML5Audio||!c.hasHTML5)return!1;var e=a.url||null,a=a.type||null,b=c.audioFormats,f;if(a&&"undefined"!==typeof c.html5[a])return c.html5[a]&&!d(a);if(!D){D=[];for(f in b)b.hasOwnProperty(f)&&
(D.push(f),b[f].related&&(D=D.concat(b[f].related)));D=RegExp("\\.("+D.join("|")+")(\\?.*)?$","i")}f=e?e.toLowerCase().match(D):null;!f||!f.length?a?(e=a.indexOf(";"),f=(-1!==e?a.substr(0,e):a).substr(6)):e=!1:f=f[1];f&&"undefined"!==typeof c.html5[f]?e=c.html5[f]&&!d(f):(a="audio/"+f,e=c.html5.canPlayType({type:a}),e=(c.html5[f]=e)&&c.html5[a]&&!d(a));return e};Pa=function(){function a(a){var b,e,f=b=!1;if(!d||"function"!==typeof d.canPlayType)return b;if(a instanceof Array){for(b=0,e=a.length;b<
e&&!f;b++)if(c.html5[a[b]]||d.canPlayType(a[b]).match(c.html5Test))f=!0,c.html5[a[b]]=!0,c.flash[a[b]]=!(!c.preferFlash||!p||!a[b].match(Va));b=f}else a=d&&"function"===typeof d.canPlayType?d.canPlayType(a):!1,b=!(!a||!a.match(c.html5Test));return b}if(!c.useHTML5Audio||"undefined"===typeof Audio)return!1;var d="undefined"!==typeof Audio?cb?new Audio(null):new Audio:null,e,b={},f,g;f=c.audioFormats;for(e in f)if(f.hasOwnProperty(e)&&(b[e]=a(f[e].type),b["audio/"+e]=b[e],c.flash[e]=c.preferFlash&&
!c.ignoreFlash&&e.match(Va)?!0:!1,f[e]&&f[e].related))for(g=f[e].related.length-1;0<=g;g--)b["audio/"+f[e].related[g]]=b[e],c.html5[f[e].related[g]]=b[e],c.flash[f[e].related[g]]=b[e];b.canPlayType=d?a:null;c.html5=x(c.html5,b);return!0};aa={notReady:"Not loaded yet - wait for soundManager.onload()/onready()",notOK:"Audio support is not available.",domError:"soundManager::createMovie(): appendChild/innerHTML call failed. DOM not ready or other error.",spcWmode:"soundManager::createMovie(): Removing wmode, preventing known SWF loading issue(s)",
swf404:"soundManager: Verify that %s is a valid path.",tryDebug:"Try soundManager.debugFlash = true for more security details (output goes to SWF.)",checkSWF:"See SWF output for more debug info.",localFail:"soundManager: Non-HTTP page ("+i.location.protocol+" URL?) Review Flash player security settings for this special case:\nhttp://www.macromedia.com/support/documentation/en/flashplayer/help/settings_manager04.html\nMay need to add/allow path, eg. c:/sm2/ or /users/me/sm2/",waitFocus:"soundManager: Special case: Waiting for focus-related event..",
waitImpatient:"soundManager: Getting impatient, still waiting for Flash%s...",waitForever:"soundManager: Waiting indefinitely for Flash (will recover if unblocked)...",needFunction:"soundManager: Function object expected for %s",badID:'Warning: Sound ID "%s" should be a string, starting with a non-numeric character',currentObj:"--- soundManager._debug(): Current sound objects ---",waitEI:"soundManager::initMovie(): Waiting for ExternalInterface call from Flash..",waitOnload:"soundManager: Waiting for window.onload()",
docLoaded:"soundManager: Document already loaded",onload:"soundManager::initComplete(): calling soundManager.onload()",onloadOK:"soundManager.onload() complete",init:"soundManager::init()",didInit:"soundManager::init(): Already called?",flashJS:"soundManager: Attempting to call Flash from JS..",secNote:"Flash security note: Network/internet URLs will not load due to security restrictions. Access can be configured via Flash Player Global Security Settings Page: http://www.macromedia.com/support/documentation/en/flashplayer/help/settings_manager04.html",
badRemove:"Warning: Failed to remove flash movie.",shutdown:"soundManager.disable(): Shutting down",queue:"soundManager: Queueing %s handler",smFail:"soundManager: Failed to initialise.",smError:"SMSound.load(): Exception: JS-Flash communication failed, or JS error.",fbTimeout:"No flash response, applying .swf_timedout CSS..",fbLoaded:"Flash loaded",fbHandler:"soundManager::flashBlockHandler()",manURL:"SMSound.load(): Using manually-assigned URL",onURL:"soundManager.load(): current URL already assigned.",
badFV:'soundManager.flashVersion must be 8 or 9. "%s" is invalid. Reverting to %s.',as2loop:"Note: Setting stream:false so looping can work (flash 8 limitation)",noNSLoop:"Note: Looping not implemented for MovieStar formats",needfl9:"Note: Switching to flash 9, required for MP4 formats.",mfTimeout:"Setting flashLoadTimeout = 0 (infinite) for off-screen, mobile flash case",mfOn:"mobileFlash::enabling on-screen flash repositioning",policy:"Enabling usePolicyFile for data access"};s=function(){var a=
Qa.call(arguments),c=a.shift(),c=aa&&aa[c]?aa[c]:"",e,b;if(c&&a&&a.length)for(e=0,b=a.length;e<b;e++)c=c.replace("%s",a[e]);return c};fa=function(a){if(8===k&&1<a.loops&&a.stream)o("as2loop"),a.stream=!1;return a};ga=function(a,d){if(a&&!a.usePolicyFile&&(a.onid3||a.usePeakData||a.useWaveformData||a.useEQData))c._wD((d||"")+s("policy")),a.usePolicyFile=!0;return a};ya=function(a){"undefined"!==typeof console&&"undefined"!==typeof console.warn?console.warn(a):c._wD(a)};pa=function(){return!1};Ia=function(a){for(var c in a)a.hasOwnProperty(c)&&
"function"===typeof a[c]&&(a[c]=pa)};ea=function(a){"undefined"===typeof a&&(a=!1);if(w||a)o("smFail",2),c.disable(a)};Ja=function(a){var d=null;if(a)if(a.match(/\.swf(\?.*)?$/i)){if(d=a.substr(a.toLowerCase().lastIndexOf(".swf?")+4))return a}else a.lastIndexOf("/")!==a.length-1&&(a+="/");a=(a&&-1!==a.lastIndexOf("/")?a.substr(0,a.lastIndexOf("/")+1):"./")+c.movieURL;c.noSWFCache&&(a+="?ts="+(new Date).getTime());return a};sa=function(){k=parseInt(c.flashVersion,10);if(8!==k&&9!==k)c._wD(s("badFV",
k,8)),c.flashVersion=k=8;var a=c.debugMode||c.debugFlash?"_debug.swf":".swf";if(c.useHTML5Audio&&!c.html5Only&&c.audioFormats.mp4.required&&9>k)c._wD(s("needfl9")),c.flashVersion=k=9;c.version=c.versionNumber+(c.html5Only?" (HTML5-only mode)":9===k?" (AS3/Flash 9)":" (AS2/Flash 8)");8<k?(c.defaultOptions=x(c.defaultOptions,c.flash9Options),c.features.buffering=!0,c.defaultOptions=x(c.defaultOptions,c.movieStarOptions),c.filePatterns.flash9=RegExp("\\.(mp3|"+Ya.join("|")+")(\\?.*)?$","i"),c.features.movieStar=
!0):c.features.movieStar=!1;c.filePattern=c.filePatterns[8!==k?"flash9":"flash8"];c.movieURL=(8===k?"soundmanager2.swf":"soundmanager2_flash9.swf").replace(".swf",a);c.features.peakData=c.features.waveformData=c.features.eqData=8<k};Ha=function(a,c){if(!h)return!1;h._setPolling(a,c)};va=function(){if(c.debugURLParam.test(P))c.debugMode=!0;if(z(c.debugID))return!1;var a,d,e,b;if(c.debugMode&&!z(c.debugID)&&(!Ta||!c.useConsole||!c.consoleOnly)){a=i.createElement("div");a.id=c.debugID+"-toggle";d={position:"fixed",
bottom:"0px",right:"0px",width:"1.2em",height:"1.2em",lineHeight:"1.2em",margin:"2px",textAlign:"center",border:"1px solid #999",cursor:"pointer",background:"#fff",color:"#333",zIndex:10001};a.appendChild(i.createTextNode("-"));a.onclick=Ka;a.title="Toggle SM2 debug console";if(v.match(/msie 6/i))a.style.position="absolute",a.style.cursor="hand";for(b in d)d.hasOwnProperty(b)&&(a.style[b]=d[b]);d=i.createElement("div");d.id=c.debugID;d.style.display=c.debugMode?"block":"none";if(c.debugMode&&!z(a.id)){try{e=
ca(),e.appendChild(a)}catch(f){throw Error(s("domError")+" \n"+f.toString());}e.appendChild(d)}}};t=this.getSoundById;o=function(a,d){return!a?"":c._wD(s(a),d)};if(P.indexOf("sm2-debug=alert")+1&&c.debugMode)c._wD=function(a){H.alert(a)};Ka=function(){var a=z(c.debugID),d=z(c.debugID+"-toggle");if(!a)return!1;qa?(d.innerHTML="+",a.style.display="none"):(d.innerHTML="-",a.style.display="block");qa=!qa};y=function(a,c,e){if("undefined"!==typeof sm2Debugger)try{sm2Debugger.handleEvent(a,c,e)}catch(b){}return!0};
M=function(){var a=[];c.debugMode&&a.push("sm2_debug");c.debugFlash&&a.push("flash_debug");c.useHighPerformance&&a.push("high_performance");return a.join(" ")};xa=function(){var a=s("fbHandler"),d=c.getMoviePercent(),e={type:"FLASHBLOCK"};if(c.html5Only)return!1;if(c.ok()){if(c.didFlashBlock&&c._wD(a+": Unblocked"),c.oMC)c.oMC.className=[M(),"movieContainer","swf_loaded"+(c.didFlashBlock?" swf_unblocked":"")].join(" ")}else{if(A)c.oMC.className=M()+" movieContainer "+(null===d?"swf_timedout":"swf_error"),
c._wD(a+": "+s("fbTimeout")+(d?" ("+s("fbLoaded")+")":""));c.didFlashBlock=!0;I({type:"ontimeout",ignoreInit:!0,error:e});L(e)}};ra=function(a,c,e){"undefined"===typeof C[a]&&(C[a]=[]);C[a].push({method:c,scope:e||null,fired:!1})};I=function(a){a||(a={type:c.ok()?"onready":"ontimeout"});if(!r&&a&&!a.ignoreInit||"ontimeout"===a.type&&(c.ok()||w&&!a.ignoreInit))return!1;var d={success:a&&a.ignoreInit?c.ok():!w},e=a&&a.type?C[a.type]||[]:[],b=[],f,g=[d],i=A&&c.useFlashBlock&&!c.ok();if(a.error)g[0].error=
a.error;for(d=0,f=e.length;d<f;d++)!0!==e[d].fired&&b.push(e[d]);if(b.length){c._wD("soundManager: Firing "+b.length+" "+a.type+"() item"+(1===b.length?"":"s"));for(d=0,f=b.length;d<f;d++)if(b[d].scope?b[d].method.apply(b[d].scope,g):b[d].method.apply(this,g),!i)b[d].fired=!0}return!0};J=function(){l.setTimeout(function(){c.useFlashBlock&&xa();I();c.onload instanceof Function&&(o("onload",1),c.onload.apply(l),o("onloadOK",1));c.waitForWindowLoad&&j.add(l,"load",J)},1)};Ca=function(){if(void 0!==p)return p;
var a=!1,c=navigator,e=c.plugins,b,f=l.ActiveXObject;if(e&&e.length)(c=c.mimeTypes)&&c["application/x-shockwave-flash"]&&c["application/x-shockwave-flash"].enabledPlugin&&c["application/x-shockwave-flash"].enabledPlugin.description&&(a=!0);else if("undefined"!==typeof f){try{b=new f("ShockwaveFlash.ShockwaveFlash")}catch(g){}a=!!b}return p=a};Oa=function(){var a,d;if(la&&v.match(/os (1|2|3_0|3_1)/i)){if(c.hasHTML5=!1,c.html5Only=!0,c.oMC)c.oMC.style.display="none"}else if(c.useHTML5Audio)!c.html5||
!c.html5.canPlayType?(c._wD("SoundManager: No HTML5 Audio() support detected."),c.hasHTML5=!1):c.hasHTML5=!0,Da&&c._wD("soundManager::Note: Buggy HTML5 Audio in Safari on this OS X release, see https://bugs.webkit.org/show_bug.cgi?id=32159 - "+(!p?" would use flash fallback for MP3/MP4, but none detected.":"will use flash fallback for MP3/MP4, if available"),1);if(c.useHTML5Audio&&c.hasHTML5)for(d in c.audioFormats)if(c.audioFormats.hasOwnProperty(d)&&(c.audioFormats[d].required&&!c.html5.canPlayType(c.audioFormats[d].type)||
c.flash[d]||c.flash[c.audioFormats[d].type]))a=!0;c.ignoreFlash&&(a=!1);c.html5Only=c.hasHTML5&&c.useHTML5Audio&&!a;return!c.html5Only};ja=function(a){var d,e,b=0;if(a instanceof Array){for(d=0,e=a.length;d<e;d++)if(a[d]instanceof Object){if(c.canPlayMIME(a[d].type)){b=d;break}}else if(c.canPlayURL(a[d])){b=d;break}if(a[b].url)a[b]=a[b].url;a=a[b]}return a};La=function(a){if(!a._hasTimer)a._hasTimer=!0,!ma&&c.html5PollingInterval&&(null===U&&0===ia&&(U=H.setInterval(Na,c.html5PollingInterval)),ia++)};
Ma=function(a){if(a._hasTimer)a._hasTimer=!1,!ma&&c.html5PollingInterval&&ia--};Na=function(){var a;if(null!==U&&!ia)return H.clearInterval(U),U=null,!1;for(a=c.soundIDs.length-1;0<=a;a--)c.sounds[c.soundIDs[a]].isHTML5&&c.sounds[c.soundIDs[a]]._hasTimer&&c.sounds[c.soundIDs[a]]._onTimer()};L=function(a){a="undefined"!==typeof a?a:{};c.onerror instanceof Function&&c.onerror.apply(l,[{type:"undefined"!==typeof a.type?a.type:null}]);"undefined"!==typeof a.fatal&&a.fatal&&c.disable()};Ra=function(){if(!Da||
!Ca())return!1;var a=c.audioFormats,d,e;for(e in a)if(a.hasOwnProperty(e)&&("mp3"===e||"mp4"===e))if(c._wD("soundManager: Using flash fallback for "+e+" format"),c.html5[e]=!1,a[e]&&a[e].related)for(d=a[e].related.length-1;0<=d;d--)c.html5[a[e].related[d]]=!1};this._setSandboxType=function(a){var d=c.sandbox;d.type=a;d.description=d.types["undefined"!==typeof d.types[a]?a:"unknown"];c._wD("Flash security sandbox type: "+d.type);if("localWithFile"===d.type)d.noRemote=!0,d.noLocal=!1,o("secNote",2);
else if("localWithNetwork"===d.type)d.noRemote=!1,d.noLocal=!0;else if("localTrusted"===d.type)d.noRemote=!1,d.noLocal=!1};this._externalInterfaceOK=function(a,d){if(c.swfLoaded)return!1;var e,b=(new Date).getTime();c._wD("soundManager::externalInterfaceOK()"+(a?" (~"+(b-a)+" ms)":""));y("swf",!0);y("flashtojs",!0);c.swfLoaded=!0;N=!1;Da&&Ra();if(!d||d.replace(/\+dev/i,"")!==c.versionNumber.replace(/\+dev/i,""))return e='soundManager: Fatal: JavaScript file build "'+c.versionNumber+'" does not match Flash SWF build "'+
d+'" at '+c.url+". Ensure both are up-to-date.",setTimeout(function(){throw Error(e);},0),!1;E?setTimeout(Y,100):Y()};da=function(a,d){function e(){c._wD("-- SoundManager 2 "+c.version+(!c.html5Only&&c.useHTML5Audio?c.hasHTML5?" + HTML5 audio":", no HTML5 audio support":"")+(!c.html5Only?(c.useHighPerformance?", high performance mode, ":", ")+((c.flashPollingInterval?"custom ("+c.flashPollingInterval+"ms)":"normal")+" polling")+(c.wmode?", wmode: "+c.wmode:"")+(c.debugFlash?", flash debug mode":"")+
(c.useFlashBlock?", flashBlock mode":""):"")+" --",1)}function b(a,b){return'<param name="'+a+'" value="'+b+'" />'}if(Q&&R)return!1;if(c.html5Only)return sa(),e(),c.oMC=z(c.movieID),Y(),R=Q=!0,!1;var f=d||c.url,g=c.altURL||f,h;h=ca();var m,l,j=M(),k,n=null,n=(n=i.getElementsByTagName("html")[0])&&n.dir&&n.dir.match(/rtl/i),a="undefined"===typeof a?c.id:a;sa();c.url=Ja(O?f:g);d=c.url;c.wmode=!c.wmode&&c.useHighPerformance?"transparent":c.wmode;if(null!==c.wmode&&(v.match(/msie 8/i)||!E&&!c.useHighPerformance)&&
navigator.platform.match(/win32|win64/i))o("spcWmode"),c.wmode=null;h={name:a,id:a,src:d,quality:"high",allowScriptAccess:c.allowScriptAccess,bgcolor:c.bgColor,pluginspage:Wa+"www.macromedia.com/go/getflashplayer",title:"JS/Flash audio component (SoundManager 2)",type:"application/x-shockwave-flash",wmode:c.wmode,hasPriority:"true"};if(c.debugFlash)h.FlashVars="debug=1";c.wmode||delete h.wmode;if(E)f=i.createElement("div"),l=['<object id="'+a+'" data="'+d+'" type="'+h.type+'" title="'+h.title+'" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="'+
Wa+'download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0">',b("movie",d),b("AllowScriptAccess",c.allowScriptAccess),b("quality",h.quality),c.wmode?b("wmode",c.wmode):"",b("bgcolor",c.bgColor),b("hasPriority","true"),c.debugFlash?b("FlashVars",h.FlashVars):"","</object>"].join("");else for(m in f=i.createElement("embed"),h)h.hasOwnProperty(m)&&f.setAttribute(m,h[m]);va();j=M();if(h=ca())if(c.oMC=z(c.movieID)||i.createElement("div"),c.oMC.id){k=c.oMC.className;c.oMC.className=
(k?k+" ":"movieContainer")+(j?" "+j:"");c.oMC.appendChild(f);if(E)m=c.oMC.appendChild(i.createElement("div")),m.className="sm2-object-box",m.innerHTML=l;R=!0}else{c.oMC.id=c.movieID;c.oMC.className="movieContainer "+j;m=j=null;if(!c.useFlashBlock)if(c.useHighPerformance)j={position:"fixed",width:"8px",height:"8px",bottom:"0px",left:"0px",overflow:"hidden"};else if(j={position:"absolute",width:"6px",height:"6px",top:"-9999px",left:"-9999px"},n)j.left=Math.abs(parseInt(j.left,10))+"px";if(bb)c.oMC.style.zIndex=
1E4;if(!c.debugFlash)for(k in j)j.hasOwnProperty(k)&&(c.oMC.style[k]=j[k]);try{E||c.oMC.appendChild(f);h.appendChild(c.oMC);if(E)m=c.oMC.appendChild(i.createElement("div")),m.className="sm2-object-box",m.innerHTML=l;R=!0}catch(p){throw Error(s("domError")+" \n"+p.toString());}}Q=!0;e();c._wD("soundManager::createMovie(): Trying to load "+d+(!O&&c.altURL?" (alternate URL)":""),1);return!0};ba=function(){if(c.html5Only)return da(),!1;if(h)return!1;h=c.getMovie(c.id);if(!h)T?(E?c.oMC.innerHTML=wa:c.oMC.appendChild(T),
T=null,Q=!0):da(c.id,c.url),h=c.getMovie(c.id);h&&o("waitEI");c.oninitmovie instanceof Function&&setTimeout(c.oninitmovie,1);return!0};$=function(){setTimeout(Ga,1E3)};Ga=function(){if(ha)return!1;ha=!0;j.remove(l,"load",$);if(N&&!Ea)return o("waitFocus"),!1;var a;r||(a=c.getMoviePercent(),c._wD(s("waitImpatient",100===a?" (SWF loaded)":0<a?" (SWF "+a+"% loaded)":"")));setTimeout(function(){a=c.getMoviePercent();r||(c._wD("soundManager: No Flash response within expected time.\nLikely causes: "+(0===
a?"Loading "+c.movieURL+" may have failed (and/or Flash "+k+"+ not present?), ":"")+"Flash blocked or JS-Flash security error."+(c.debugFlash?" "+s("checkSWF"):""),2),!O&&a&&(o("localFail",2),c.debugFlash||o("tryDebug",2)),0===a&&c._wD(s("swf404",c.url)),y("flashtojs",!1,": Timed out"+O?" (Check flash security or flash blockers)":" (No plugin/missing SWF?)"));!r&&Ua&&(null===a?c.useFlashBlock||0===c.flashLoadTimeout?(c.useFlashBlock&&xa(),o("waitForever")):ea(!0):0===c.flashLoadTimeout?o("waitForever"):
ea(!0))},c.flashLoadTimeout)};F=function(){function a(){j.remove(l,"focus",F);j.remove(l,"load",F)}if(Ea||!N)return a(),!0;Ea=Ua=!0;c._wD("soundManager::handleFocus()");W&&N&&j.remove(l,"mousemove",F);ha=!1;a();return!0};Sa=function(){var a,d=[];if(c.useHTML5Audio&&c.hasHTML5){for(a in c.audioFormats)c.audioFormats.hasOwnProperty(a)&&d.push(a+": "+c.html5[a]+(!c.html5[a]&&p&&c.flash[a]?" (using flash)":c.preferFlash&&c.flash[a]&&p?" (preferring flash)":!c.html5[a]?" ("+(c.audioFormats[a].required?
"required, ":"")+"and no flash support)":""));c._wD("-- SoundManager 2: HTML5 support tests ("+c.html5Test+"): "+d.join(", ")+" --",1)}};S=function(a){if(r)return!1;if(c.html5Only)return c._wD("-- SoundManager 2: loaded --"),r=!0,J(),y("onload",!0),!0;var d=!0,e;if(!c.useFlashBlock||!c.flashLoadTimeout||c.getMoviePercent())r=!0,w&&(e={type:!p&&A?"NO_FLASH":"INIT_TIMEOUT"});c._wD("-- SoundManager 2 "+(w?"failed to load":"loaded")+" ("+(w?"security/load error":"OK")+") --",1);if(w||a){if(c.useFlashBlock&&
c.oMC)c.oMC.className=M()+" "+(null===c.getMoviePercent()?"swf_timedout":"swf_error");I({type:"ontimeout",error:e});y("onload",!1);L(e);d=!1}else y("onload",!0);c.waitForWindowLoad&&!Z?(o("waitOnload"),j.add(l,"load",J)):(c.waitForWindowLoad&&Z&&o("docLoaded"),J());return d};Y=function(){o("init");if(r)return o("didInit"),!1;if(c.html5Only){if(!r)j.remove(l,"load",c.beginDelayedInit),c.enabled=!0,S();return!0}ba();try{o("flashJS"),h._externalInterfaceTest(!1),Ha(!0,c.flashPollingInterval||(c.useHighPerformance?
10:50)),c.debugMode||h._disableDebug(),c.enabled=!0,y("jstoflash",!0),c.html5Only||j.add(l,"unload",pa)}catch(a){return c._wD("js/flash exception: "+a.toString()),y("jstoflash",!1),L({type:"JS_TO_FLASH_EXCEPTION",fatal:!0}),ea(!0),S(),!1}S();j.remove(l,"load",c.beginDelayedInit);return!0};K=function(){if(ua)return!1;ua=!0;va();var a=P.toLowerCase(),d=null,d=null,e="undefined"!==typeof console&&"undefined"!==typeof console.log;if(-1!==a.indexOf("sm2-usehtml5audio="))d="1"===a.charAt(a.indexOf("sm2-usehtml5audio=")+
18),e&&console.log((d?"Enabling ":"Disabling ")+"useHTML5Audio via URL parameter"),c.useHTML5Audio=d;if(-1!==a.indexOf("sm2-preferflash="))d="1"===a.charAt(a.indexOf("sm2-preferflash=")+16),e&&console.log((d?"Enabling ":"Disabling ")+"preferFlash via URL parameter"),c.preferFlash=d;if(!p&&c.hasHTML5)c._wD("SoundManager: No Flash detected"+(!c.useHTML5Audio?", enabling HTML5.":". Trying HTML5-only mode.")),c.useHTML5Audio=!0,c.preferFlash=!1;Pa();c.html5.usingFlash=Oa();A=c.html5.usingFlash;Sa();if(!p&&
A)c._wD("SoundManager: Fatal error: Flash is needed to play some required formats, but is not available."),c.flashLoadTimeout=1;i.removeEventListener&&i.removeEventListener("DOMContentLoaded",K,!1);ba();return!0};Ba=function(){"complete"===i.readyState&&(K(),i.detachEvent("onreadystatechange",Ba));return!0};ta=function(){Z=!0;j.remove(l,"load",ta)};Ca();j.add(l,"focus",F);j.add(l,"load",F);j.add(l,"load",$);j.add(l,"load",ta);W&&N&&j.add(l,"mousemove",F);i.addEventListener?i.addEventListener("DOMContentLoaded",
K,!1):i.attachEvent?i.attachEvent("onreadystatechange",Ba):(y("onload",!1),L({type:"NO_DOM2_EVENTS",fatal:!0}));"complete"===i.readyState&&setTimeout(K,100)}var na=null;if("undefined"===typeof SM2_DEFER||!SM2_DEFER)na=new X;H.SoundManager=X;H.soundManager=na})(window);

soundManager.url = '/WebSpeech/soundmanager2';
soundManager.debugMode = false;
soundManager.onready(function() { WebSpeech.sm2ready = true; });
}
